<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
$require_variable = 1;

if($_SERVER["HTTPS"] != "on")
{
    header("Location: https://" . $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"]);
    die();
}

session_start();

if (isset($_POST['device_id']) && isset($_POST['user_id']) && isset($_POST['menu_command']) && isset($_POST['loafsize_command']) && isset($_POST['browning_command']) && isset($_POST['countdown_command']) && isset($_SESSION['id']))
{
	$device_id = intval($_POST['device_id']);
	$user_id = intval($_POST['user_id']);
	$menu_command = intval($_POST['menu_command']);
	$loafsize_command = intval($_POST['loafsize_command']);
	$browning_command = intval($_POST['browning_command']);
	$countdown_command = intval($_POST['countdown_command']);

	if ($_SESSION['rank'] == 1 || $_SESSION['id'] == $user_id)
	{
		require 'php_scripts/db_connect_script.php';
		$sth = $dbh->prepare("SELECT device_name, menu_status, loafsize_status, browning_status, device_status, countdown_status, motor_status, heater_status, update_timestamp FROM devices WHERE device_id=:device_id LIMIT 1;");
		$sth->execute(array(':device_id' => $device_id));
		$result = $sth->fetch();
		$device_name = $result['device_name'];
		$device_status = $result['device_status'];
		
		date_default_timezone_set('Europe/Athens');
		if (time() - strtotime($result['update_timestamp']) <= 20)
		{
			if ($device_status != 1 && $device_status != 2)
			{
				$sth = $dbh->prepare("UPDATE commands SET commands_timestamp=NOW(), menu_command=:menu_command, loafsize_command=:loafsize_command, browning_command=:browning_command, countdown_command=:countdown_command, start_command='1', stop_command='0' WHERE device_id=:device_id LIMIT 1;");
				$sth->execute(array(':device_id' => $device_id, ':menu_command' => $menu_command, ':loafsize_command' => $loafsize_command, ':browning_command' => $browning_command, ':countdown_command' => $countdown_command));
				$results = array('status' => 'Η εντολή εστάλη.');
				
				if ($_SESSION['id'] == $user_id)
				{
					$user_name = $_SESSION['user_name'];
					$action_description = "Ο χρήστης \"$user_name\" (Α/Α: $user_id) ξεκίνησε την συσκευή \"$device_name\" (Α/Α: $device_id) με τις εξής εντολές: πρόγραμμα->$menu_command, μέγεθος->$loafsize_command, απόχρωση->$browning_command, χρόνος->$countdown_command.";
					$sth = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
					$sth->execute(array(':user_name' => $user_name, ':action_description' => $action_description));
					$dbh = NULL;
				}
				else
				{
					$sth = $dbh->prepare("SELECT user_name FROM users WHERE user_id=:user_id LIMIT 1;");
					$sth->execute(array(':user_id' => $user_id));
					$result = $sth->fetch();
					$user_name = $result['user_name'];
					
					$admin_id = $_SESSION['id'];
					$admin_name = $_SESSION['user_name'];
					$action_description = "Ο διαχειριστής \"$admin_name\" (Α/Α: $admin_id) ξεκίνησε την συσκευή \"$device_name\" (Α/Α: $device_id) που ανήκει στον χρήστη \"$user_name\" (Α/Α: $user_id) με τις εξής εντολές: πρόγραμμα->$menu_command, μέγεθος->$loafsize_command, απόχρωση->$browning_command, χρόνος->$countdown_command.";
					$sth = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
					$sth->execute(array(':user_name' => $admin_name, ':action_description' => $action_description));
					$dbh = NULL;
				}
			}
			else if ($device_status == 1 || $device_status == 2)
			{
				$sth = $dbh->prepare("UPDATE commands SET commands_timestamp=NOW(), start_command='0', stop_command='1' WHERE device_id=:device_id LIMIT 1;");
				$sth->execute(array(':device_id' => $device_id));
				$results = array('status' => 'Η εντολή εστάλη.');
				
				if ($_SESSION['id'] == $user_id)
				{
					$user_name = $_SESSION['user_name'];
					$action_description = "Ο χρήστης \"$user_name\" (Α/Α: $user_id) σταμάτησε την συσκευή \"$device_name\" (Α/Α: $device_id).";
					$sth = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
					$sth->execute(array(':user_name' => $user_name, ':action_description' => $action_description));
					$dbh = NULL;
				}
				else
				{
					$sth = $dbh->prepare("SELECT user_name FROM users WHERE user_id=:user_id LIMIT 1;");
					$sth->execute(array(':user_id' => $user_id));
					$result = $sth->fetch();
					$user_name = $result['user_name'];
					
					$admin_id = $_SESSION['id'];
					$admin_name = $_SESSION['user_name'];
					$action_description = "Ο διαχειριστής \"$admin_name\" (Α/Α: $admin_id) σταμάτησε την συσκευή \"$device_name\" (Α/Α: $device_id) που ανήκει στον χρήστη \"$user_name\" (Α/Α: $user_id).";
					$sth = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
					$sth->execute(array(':user_name' => $admin_name, ':action_description' => $action_description));
					$dbh = NULL;
				}
			}
		}
		else
		{
			$results = array('status' => 'Η συσκευή είναι εκτός σύνδεσης.');
		}
		$results = json_encode($results);
		echo $results;
	}
	else
	{
		die("Warrup dude!");
	}

}
else if (isset($_POST['device_id']) && isset($_POST['user_id']) && isset($_SESSION['id']))
{
	$device_id = intval($_POST['device_id']);
	$user_id = intval($_POST['user_id']);

	if ($_SESSION['rank'] == 1 || $_SESSION['id'] == $user_id)
	{
		require 'php_scripts/db_connect_script.php';
		$sth = $dbh->prepare("SELECT menu_status, loafsize_status, browning_status, device_status, countdown_status, motor_status, heater_status, update_timestamp FROM devices WHERE device_id=:device_id LIMIT 1;");
		$sth->execute(array(':device_id' => $device_id));
		$result = $sth->fetch();
		
		date_default_timezone_set('Europe/Athens');
		if (time() - strtotime($result['update_timestamp']) <= 10)
		{
			$results = array('network_status' => 'Online', 'menu_status' => $result['menu_status'],  'loafsize_status' => $result['loafsize_status'],  'browning_status' => $result['browning_status'],  'device_status' => $result['device_status'],  'countdown_status' => $result['countdown_status'],  'motor_status' => $result['motor_status'],  'heater_status' => $result['heater_status']);
		}
		else
		{
			$results = array('network_status' => 'Offline');
		}
		$results = json_encode($results);
		echo $results;
	}
	else
	{
		die("Warrup dude!");
	}
}
else
{
	die("Warrup dude!");
}
exit();
?>