<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
// collect data from device and transmit data to device
// timer start
//$execution_time_start = microtime(true);
$require_variable = 1;

// if URL values are present, assign them to variables, else show an empty page
if (isset($_GET['menu']) && isset($_GET['loafsize']) && isset($_GET['browning']) && isset($_GET['status']) && isset($_GET['countdown']) && isset($_GET['motor']) && isset($_GET['heater']) && isset($_GET['device_id']) && isset($_GET['device_hash']) && isset($_GET['status_change']))
{
	require 'php_scripts/db_connect_script.php';
    $menu_status = intval($_GET['menu']);
    $loafsize_status = intval($_GET['loafsize']);
    $browning_status = intval($_GET['browning']);
    $device_status = intval($_GET['status']);
    $countdown_status = intval($_GET['countdown']);
    $motor_status = intval($_GET['motor']);
    $heater_status = intval($_GET['heater']);
    $device_id = intval($_GET['device_id']);
    $device_hash = strip_tags($_GET['device_hash']);
    $device_status_change = intval($_GET['status_change']);
    date_default_timezone_set('Europe/Athens');
	$now = time();
    
    // find if device exists
    $sth = $dbh->prepare("SELECT device_id, device_hash FROM devices WHERE device_id=:device_id LIMIT 1;");
    $sth->execute(array(':device_id' => $device_id));
    
    if ($sth->rowCount() == 1)
    {
		$result = $sth->fetch();
		
		if (($device_hash == $result['device_hash'])) // check device credentials
		{
			echo "$$ "; // print success pattern
			
			if ($device_status == 0 && $device_status_change == 0)
			{
				if ($menu_status == 1 && $loafsize_status == 0 && $browning_status == 0 && $countdown_status == 10380) // if device seems to have lost power keep last known values
				{
					// check last task info
					$sth = $dbh->prepare("SELECT timestamp, menu_status, loafsize_status, browning_status, countdown_status, status_change FROM devices_logs WHERE device_id=:device_id ORDER BY timestamp DESC LIMIT 1;");
    				$sth->execute(array(':device_id' => $device_id));
    				$result = $sth->fetch();
    				
					$log_menu = $result['menu_status'];
					$log_loafsize = $result['loafsize_status'];
					$log_browning = $result['browning_status'];
					$log_timestamp = strtotime($result['timestamp']);
					$log_countdown = $result['countdown_status'];
					$log_status_change = $result['status_change'];
					
					// check if last log entry could still be of an active task
					if ((($now - $log_timestamp) < $log_countdown) && $log_status_change == 1)
					{
						//fetch last state countdown
						$sth = $dbh->prepare("SELECT countdown_status FROM devices WHERE device_id=:device_id LIMIT 1;");
						$sth->execute(array(':device_id' => $device_id));
    					$result = $sth->fetch();
    					
    					$last_countdown = $result['countdown_status']; // last known countdown from "devices" table
						
						// restore previous state
						$sth = $dbh->prepare("UPDATE commands SET commands_timestamp=NOW(), start_command='1', menu_command=:menu_command, loafsize_command=:loafsize_command, browning_command=:browning_command, countdown_command=:countdown_command WHERE device_id=:device_id LIMIT 1;");
						$sth->execute(array(':device_id' => $device_id, ':menu_command' => $log_menu, ':loafsize_command' => $log_loafsize, ':browning_command' => $log_browning, ':countdown_command' => $last_countdown));
					}
				}
			}
			
			// fetch commands for device from db
			$sth = $dbh->prepare("SELECT commands_timestamp, menu_command, loafsize_command, browning_command, countdown_command, start_command, stop_command FROM commands WHERE device_id=:device_id LIMIT 1;");
			$sth->execute(array(':device_id' => $device_id));
			$result = $sth->fetch();
			
			if ($now - strtotime($result['commands_timestamp']) <= 20 || $result['stop_command'] == 1) // if commands where sent in last 20 seconds or a cancelation was requested
			{
				// print the commands
				echo $result['menu_command'] . " " . $result['loafsize_command'] . " " . $result['browning_command'] . " " . $result['countdown_command'] . " " . $result['start_command'] . " " . $result['stop_command'];
			}
            else
            {
				echo $result['menu_command'] . " 0 0 10380 0 0"; // ignore last commands
			}
			
			// restore start & stop commands after they are read
			$sth = $dbh->prepare("UPDATE commands SET start_command='0', stop_command='0' WHERE device_id=:device_id LIMIT 1;");
			$sth->execute(array(':device_id' => $device_id));
			
			// if status changes, insert new status values to log
			if ($device_status_change != 0)
			{
				$sth = $dbh->prepare("INSERT INTO devices_logs (log_id, timestamp, device_id, menu_status, loafsize_status, browning_status, countdown_status, device_status, status_change) VALUES ('', NOW(), :device_id, :menu_status, :loafsize_status, :browning_status, :countdown_status, :device_status, :device_status_change);");
				$sth->execute(array(':device_id' => $device_id, ':menu_status' => $menu_status, ':loafsize_status' => $loafsize_status, ':browning_status' => $browning_status, ':countdown_status' => $countdown_status, ':device_status' => $device_status, ':device_status_change' => $device_status_change));
			}
			
			// send device status to db
			$sth = $dbh->prepare("UPDATE devices SET menu_status=:menu_status, loafsize_status=:loafsize_status, browning_status=:browning_status, device_status=:device_status, countdown_status=:countdown_status, motor_status=:motor_status, heater_status=:heater_status, update_timestamp=NOW() WHERE device_id=:device_id LIMIT 1;");
			$sth->execute(array(':menu_status' => $menu_status, ':loafsize_status' => $loafsize_status, ':browning_status' => $browning_status, ':device_status' => $device_status, ':countdown_status' => $countdown_status, ':motor_status' => $motor_status, ':heater_status' => $heater_status, ':device_id' => $device_id));
		}
		else
		{
			echo "$$ 0 0 0 0 0 0"; // no device found (credentials error)
		}
	}
}

// disconnect from database
$dbh = NULL;

// timer end
//$execution_time_end = microtime(true);
//$execution_time = ($execution_time_end - $execution_time_start);
//echo "<p>Total Execution Time: ".$execution_time."sec</p>";
exit();
?>
