<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
if (!isset($require_variable))
{
	header("Location: ../index.php");
	die();
}
$sth = $dbh->prepare("SELECT COUNT(*) FROM devices WHERE user_id=:user_id");
$sth->execute(array(':user_id' => $user_id));
$result = $sth->fetch(PDO::FETCH_NUM);
$rows_num = $result['0'];

if ($rows_num > 0)
{
	echo "<a name='table1'>";
	require 'php_pagination/user_admin_manage_devices_pagination.php';
	echo "</a>";
	$sth = $dbh->prepare("SELECT device_id, device_name, registration_timestamp, device_status FROM devices WHERE user_id=:user_id ORDER BY registration_timestamp LIMIT :select_limit OFFSET :select_offset;");
	$sth->execute(array(':user_id' => $user_id, ':select_limit' => $devices_select_limit, ':select_offset' => $devices_select_offset));
	echo "<div class='row'><form action='user_admin_manage.php?user_id=$user_id' name='user_admin_devices_form' method='POST'>";
	echo "<table class='table table-hover table-striped'><tr><th><input type='checkbox' name='check_all_devices' value='0'></th><th>Α/Α</th><th>Όνομα Συσκευής</th><th>Ημ. Δημιουργίας</th><th>Κατάσταση</th><th></th></tr>\n";
	while ($result = $sth->fetch())
	{
		$device_id = $result['device_id'];
		$device_name = $result['device_name'];
		if ($result['device_status'] == 0)
		{
			$status = "Αδρανής";
		}
		else if ($result['device_status'] == 1)
		{
			$status = "Χειροκίνητος Έλεγχος";
		}
		else if ($result['device_status'] == 2)
		{
			$status = "Απομακρυσμένος Έλεγχος";
		}
		else if ($result['device_status'] == 3)
		{
			$status = "Ολοκλήρωση";
		}
		else if ($result['device_status'] == 4)
		{
			$status = "Ακύρωση";
		}	
		echo "<tr><td><input type='checkbox' name='device_id[]' value='$device_id'></td><td>$device_id</td><td>" . $result['device_name'] . "</td><td>" . $result['registration_timestamp'] . "</td><td>$status</td><td><a href='user_admin_device_manage.php?user_id=$user_id&device_id=$device_id'>Διαχείριση</a></td></tr>\n";
	}
	echo "</table>";
	echo "<input type='submit' name='delete_devices' class='btn btn-md btn-danger table_button form_button' value='Διαγραφή'>";
	echo "</form></div><hr />";
}
else
{
	echo "<div class='row'><div class='alert alert-info' role='alert'>Αυτός ο χρήστης δεν έχει συσκευές.</div></div><hr />";
}

$sth = $dbh->prepare("SELECT COUNT(*) FROM users_logs WHERE user_name=:user_name;");
$sth->execute(array(':user_name' => $user_name));
$result = $sth->fetch(PDO::FETCH_NUM);
$rows_num = $result['0'];

if ($rows_num > 0)
{
	echo "<a name='table2'>";
	require 'php_pagination/user_admin_manage_logs_pagination.php';
	echo "</a>";
	$sth = $dbh->prepare("SELECT log_id, timestamp, action_description FROM users_logs WHERE user_name=:user_name ORDER BY log_id DESC LIMIT :select_limit OFFSET :select_offset;");
	$sth->execute(array(':user_name' => $user_name, ':select_limit' => $logs_select_limit, ':select_offset' => $logs_select_offset));
	echo "<div class='row'><form action='user_admin_manage.php?user_id=$user_id' name='user_admin_devices_form' method='POST'>";
	echo "<table class='table table-hover table-striped'><tr><th><input type='checkbox' name='check_all_logs' value='0'></th><th>Α/Α</th><th>Χρονοσφραγίδα</th><th>Ενέργεια</th></tr>\n";
	while ($result = $sth->fetch())
	{
		$log_id = $result['log_id'];
		$timestamp = $result['timestamp'];
		$action_description = $result['action_description'];
		
		echo "<tr><td><input type='checkbox' name='log_id[]' value='$log_id'></td><td>$log_id</td><td>$timestamp</td><td>$action_description</td></tr>\n";
	}
	echo "</table>";
	echo "<input type='submit' name='delete_logs' class='btn btn-md btn-danger table_button form_button' value='Διαγραφή'>";
	echo "</form></div>";
}
else
{
	echo "<div class='row'><div class='alert alert-info' role='alert'>Αυτός ο χρήστης δεν έχει καταγεγραμμένες ενέργειες.</div></div>";
}
?>