<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
if (!isset($require_variable))
{
	header("Location: ../index.php");
	die();
}
if (isset($_GET['id']) && isset($_GET['activation_hash']) && intval($_GET['id']))
{
	$user_id = intval($_GET['id']);
	$activation_hash = strip_tags($_GET['activation_hash']);
	
	require 'php_scripts/db_connect_script.php';
	$sth = $dbh->prepare("SELECT user_id, user_status, user_name FROM users WHERE user_id=:user_id LIMIT 1;");
    $sth->execute(array(':user_id' => $user_id));
    
    if ($sth->rowCount() == 1)
    {
    	$result = $sth->fetch();
    	$user_name = $result['user_name'];
    	if ($result['user_status'] == 0)
		{
			$sth = $dbh->prepare("SELECT activation_hash FROM user_activation WHERE user_id=:user_id LIMIT 1;");
			$sth->execute(array(':user_id' => $user_id));
			$result = $sth->fetch();
		
			if ($sth->rowCount() == 1)
			{
				if ($activation_hash == $result['activation_hash'])
				{
					$sth = $dbh->prepare("UPDATE users SET user_status='1' WHERE user_id=:user_id LIMIT 1;");
					$sth->execute(array(':user_id' => $user_id));
					
					$sth = $dbh->prepare("DELETE FROM user_activation WHERE user_id=:user_id LIMIT 1;");
					$sth->execute(array(':user_id' => $user_id));
					
					$action_description = "Ο χρήστης \"$user_name\" (Α/Α: $user_id) ενεργοποίησε τον λογαριασμό του.";
					$sth = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
					$sth->execute(array(':user_name' => $user_name, ':action_description' => $action_description));
					
					$activated = 1;
				}
				else
				{
					$dbh = NULL;
					$_SESSION['inv_link'] = 1;
					header("index.php");
				}
			}
			else
			{
				$dbh = NULL;
				$_SESSION['db_error'] = 1;
				header("index.php");
			}
		}
		else if ($result['user_status'] == 1)
		{
			$active = 1;
		}
		else if ($result['user_status'] == 2)
		{
			$banned = 1;
		}
	}
	else
	{
		$_SESSION['inv_link'] = 1;
		header("index.php");
	}
	$dbh = NULL;
}
?>		