<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
if (!isset($require_variable))
{
	header("Location: ../index.php");
	die();
}
if (!isset($_SESSION['reset_id']))
{
	if (isset($_GET['id']) && isset($_GET['reset_hash']) && intval($_GET['id']))
	{	
		$user_id = intval($_GET['id']);
		$reset_hash = strip_tags($_GET['reset_hash']);
	
		require 'php_scripts/db_connect_script.php';
		$sth = $dbh->prepare("SELECT password_reset_hash, timestamp FROM password_reset WHERE user_id=:user_id ORDER BY timestamp DESC LIMIT 1;");
    	$sth->execute(array(':user_id' => $user_id));
    	
    	if ($sth->rowCount() > 0)
    	{
    		$result = $sth->fetch();
    		date_default_timezone_set('Europe/Athens');
			$now = time();
			
			if ($now - strtotime($result['timestamp']) <= 7200 && $reset_hash == $result['password_reset_hash'])
			{
				$sth = $dbh->prepare("DELETE FROM password_reset WHERE user_id=:user_id;");
				$sth->execute(array(':user_id' => $user_id));
				
				$dbh = NULL;
				$_SESSION['reset_id'] = $user_id;
				header("reset_password.php");
			}
			else
			{
				$dbh = NULL;
				$_SESSION['inv_link'] = 1;
				header("Location: index.php");
				die();
			}
		}
		else
		{
			$dbh = NULL;
			$_SESSION['inv_link'] = 1;
			header("Location: index.php");
			die();
		}
	}
	else
	{
		$_SESSION['inv_link'] = 1;
		header("Location: index.php");
		die();
	}
}
else if (isset($_SESSION['reset_id']) && isset($_POST['new_password']) && isset($_POST['confirm_new_password']))
{
	if ($_POST['new_password'] && $_POST['confirm_new_password'])
	{
		$new_pass = $_POST['new_password'];
		$confirm_new_pass = $_POST['confirm_new_password'];
	
		if ($new_pass == $confirm_new_pass)
		{
			if (strlen($new_pass) > 3 && strlen($new_pass) < 41)
			{
				require 'php_scripts/db_connect_script.php';
				$new_pass = md5("ABBAE" . md5($new_pass));
				$sth = $dbh->prepare("UPDATE users SET password_hash=:password_hash WHERE user_id=:user_id LIMIT 1;");
				$sth->execute(array(':password_hash' => $new_pass, ':user_id' => $_SESSION['reset_id']));
				
				$sth = $dbh->prepare("SELECT user_name FROM users WHERE user_id=:user_id LIMIT 1;");
				$sth->execute(array(':user_id' => $_SESSION['reset_id']));
				$result = $sth -> fetch();
				
				$user_name = $result['user_name'];
				$user_id = $_SESSION['reset_id'];
				$action_description = "Ο χρήστης \"$user_name\" (Α/Α: $user_id) έκανε επαναφορά στον κωδικό του.";
				$sth = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
				$sth->execute(array(':user_name' => $user_name, ':action_description' => $action_description));
				
				$dbh = NULL;
				$_SESSION['password_reset'] = 1;
				header("Location: index.php");
				die();
			}
			else
			{
				$short_pass = 1;
			}
		}
		else
		{
			$pass_mismatch = 1;
		}
	}
	else
	{
		$empty_form = 1;
	}
}
else
{
	$_SESSION['inv_link'] = 1;
	header("Location: index.php");
	die();
}
?>