<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
if (!isset($require_variable))
{
	header("Location: ../index.php");
	die();
}
if (isset($_GET['user_id']) && intval($_GET['user_id']))
{
	$user_id = intval($_GET['user_id']);
	$sth = $dbh->prepare("SELECT user_name, user_status, user_email, user_rank FROM users WHERE user_id=:user_id LIMIT 1;");
	$sth->execute(array(':user_id' => $user_id));
	if ($sth -> rowCount() == 1)
	{
		$result = $sth->fetch();
		$user_rank = $result['user_rank'];
		$user_name = $result['user_name'];
		$user_status = $result['user_status'];
		$user_email = $result['user_email'];
	}
	else
	{
		$dbh = NULL;
		$_SESSION['inv_link'] = 1;
		header("Location: users_admin.php");
		die();
	}
}
else
{
	$dbh = NULL;
	$_SESSION['inv_link'] = 1;
	header("Location: users_admin.php");
	die();
}
if (isset($_POST['user_admin_device_add']))
{	
	if (isset($_POST['new_device_name']))
	{
		$new_device_name = strip_tags($_POST['new_device_name']);
		if (strlen($new_device_name) < 41)
		{	
			$sth = $dbh->prepare("SELECT COUNT(*) FROM devices WHERE user_id=$user_id AND device_name=:device_name LIMIT 1;");
			$sth->execute(array(':device_name' => $new_device_name));
			$result = $sth->fetch(PDO::FETCH_NUM);
			$num_rows = $result['0'];		
			if ($num_rows == 0)
			{
				$device_hash = md5(rand());
				$sth = $dbh->prepare("INSERT INTO devices (device_id, device_hash, registration_timestamp, menu_status, loafsize_status, browning_status, device_status, countdown_status, motor_status, heater_status, update_timestamp, device_name, user_id) VALUES ('', :device_hash, NOW(), '', '', '', '', '', '', '', '', :device_name, :user_id);");
	    		$sth->execute(array(':device_name' => $new_device_name, ':device_hash' => $device_hash, ':user_id' => $user_id));
	    		
	    		$sth = $dbh->prepare("SELECT device_id FROM devices WHERE user_id=$user_id AND device_name=:device_name LIMIT 1;");
	    		$sth->execute(array(':device_name' => $new_device_name));
	    		$result = $sth->fetch();
	    		$new_device_id = $result['device_id'];
	    		
	    		$sth = $dbh->prepare("SELECT user_name FROM users WHERE user_id=:user_id LIMIT 1;");
   	 			$sth->execute(array(':user_id' => $user_id));
   	 			$result = $sth->fetch();
   	 			
   	 			$user_name = $result['user_name'];
   	 			$admin_name = $_SESSION['user_name'];
   	 			$admin_id = $_SESSION['id'];
				$action_description = "Ο διαχειριστής \"$admin_name\" (Α/Α: $admin_id) δημιούργησε τη συσκευή \"$new_device_name\" (Α/Α: $new_device_id) για λογαριασμό του χρήστη \"$user_name\" (Α/Α: $user_id).";
				$sth_devices = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
				$sth_devices->execute(array(':user_name' => $_SESSION['user_name'], ':action_description' => $action_description));
    			
    			$sth = $dbh->prepare("INSERT INTO commands (commands_timestamp, device_id, menu_command, loafsize_command, browning_command, countdown_command, start_command, stop_command) VALUES (NOW(), :device_id, '1', '0', '0', '10380', '0', '0');");
    			$sth->execute(array(':device_id' => $new_device_id));
    			
    			$device_added = 1;
			}
			else
			{
				$inv_device_name = 1;
			}
		}
		else
		{
			$long_name = 1;
		}
	}
	else
	{
		$device_empty_form = 1;
	}
}
if (isset($_POST['delete_devices']))
{
	if (isset($_POST['device_id']))
	{
		$list = $_POST['device_id'];
		$N = count($list);	
		for ($i = 0; $i < $N; $i++)
		{
			$list[$i] = intval($list[$i]);
		
			$sth = $dbh->prepare("SELECT device_name FROM devices WHERE device_id=:device_id LIMIT 1;");
			$sth->execute(array(':device_id' => $list[$i]));
			$result = $sth->fetch();
			$device_name = $result['device_name'];
				
			$device_id = $list[$i];
			$admin_name = $_SESSION['user_name'];
			$admin_id = $_SESSION['id'];
			$action_description = "Ο διαχειριστής \"$admin_name\" (Α/Α: $admin_id) διέγραψε τη συσκευή \"$device_name\" (Α/Α: $device_id) που ανήκε στον χρήστη \"$user_name\" (Α/Α: $user_id).";
			$sth_devices = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
			$sth_devices->execute(array(':user_name' => $_SESSION['user_name'], ':action_description' => $action_description));
		
			$sth = $dbh->prepare("DELETE FROM devices WHERE device_id=:device_id LIMIT 1;");
			$sth->execute(array(':device_id' => $list[$i]));
			$sth = $dbh->prepare("DELETE FROM commands WHERE device_id=:device_id LIMIT 1;");
			$sth->execute(array(':device_id' => $list[$i]));
		}
		$devices_deleted = 1;
	}
	else
	{
		$no_devices_selections = 1;
	}
}

if (isset($_POST['delete_logs']) && isset($_POST['log_id']))
{
	$list = $_POST['log_id'];
	$N = count($list);	
	for ($i = 0; $i < $N; $i++)
	{
		$list[$i] = intval($list[$i]);
		$sth = $dbh->prepare("DELETE FROM users_logs WHERE log_id=:log_id LIMIT 1;");
		$sth->execute(array(':log_id' => $list[$i]));
	}
	$logs_deleted = 1;
}
else if (isset($_POST['delete_logs']))
{
	$no_logs_selections = 1;
}

if (isset($_POST['user_admin_manage']))
{
	if (($user_id == 1 && $_SESSION['id'] == $user_id) || $user_id != 1)
	{
		$new_email = strip_tags($_POST['email']);
		if ($new_email)
		{
			if (isset($_POST['rank']))
			{
				if (isset($_POST['status']))
				{
					$new_status = intval($_POST['status']);
				}
				else
				{
					$new_status = 0;
				}
				$new_rank = intval($_POST['rank']);
			}
			if (strlen($new_email) <= 40)
			{
				if ($new_email != $user_email)
				{
					$sth = $dbh->prepare("SELECT COUNT(*) FROM users WHERE user_email=:user_email;");
					$sth->execute(array(':user_email' => $new_email));
					$result = $sth->fetch(PDO::FETCH_NUM);
					$rows_num = $result['0'];
					
					if ($rows_num == 0)
					{
						$sth = $dbh->prepare("UPDATE users SET user_email=:user_email WHERE user_id=:user_id LIMIT 1;");
						$sth->execute(array(':user_email' => $new_email, ':user_id' => $user_id));
						
						$admin_name = $_SESSION['user_name'];
						$admin_id = $_SESSION['id'];
						$action_description = "Ο διαχειριστής \"$admin_name\" (Α/Α: $admin_id) ενημέρωσε τη διεύθυνση e-mail του χρήστη \"$user_name\" (Α/Α: $user_id) από \"$user_email\" σε \"$new_email\".";
						$sth_devices = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
						$sth_devices->execute(array(':user_name' => $_SESSION['user_name'], ':action_description' => $action_description));
						
						$user_edited = 1;
						
						if ($user_id != $_SESSION['id'])
						{
							if ($new_status != $user_status)
							{
								if ($new_status == 1)
								{
									$sth = $dbh->prepare("UPDATE users SET user_status=:user_status WHERE user_id=:user_id LIMIT 1;");
									$sth->execute(array(':user_status' => $new_status, ':user_id' => $user_id));
									
									$action_description = "Ο διαχειριστής \"$admin_name\" (Α/Α: $admin_id) άλλαξε την κατάσταση του χρήστη \"$user_name\" (Α/Α: $user_id) σε \"Ενεργός\".";
									$sth_devices = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
									$sth_devices->execute(array(':user_name' => $_SESSION['user_name'], ':action_description' => $action_description));
									
									$sth = $dbh->prepare("DELETE FROM user_activation WHERE user_id=:user_id LIMIT 1;");
									$sth->execute(array(':user_id' => $user_id));
									$sth = $dbh->prepare("SELECT device_id FROM devices WHERE user_id=:user_id;");
									$sth->execute(array(':user_id' => $user_id));
									while ($result = $sth->fetch())
									{
										$commands_sth = $dbh->prepare("UPDATE commands SET menu_command='1' WHERE device_id=:device_id;");
										$commands_sth->execute(array(':device_id' => $result['device_id']));
									}
								}
								else if ($new_status == 2)
								{
									$sth = $dbh->prepare("UPDATE users SET user_status=:user_status WHERE user_id=:user_id LIMIT 1;");
									$sth->execute(array(':user_status' => $new_status, ':user_id' => $user_id));
									
									$action_description = "Ο διαχειριστής \"$admin_name\" (Α/Α: $admin_id) άλλαξε την κατάσταση του χρήστη \"$user_name\" (Α/Α: $user_id) σε \"Αποκλεισμένος\".";
									$sth_devices = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
									$sth_devices->execute(array(':user_name' => $_SESSION['user_name'], ':action_description' => $action_description));
									
									$sth = $dbh->prepare("DELETE FROM user_activation WHERE user_id=:user_id LIMIT 1;");
									$sth->execute(array(':user_id' => $user_id));
									$sth = $dbh->prepare("DELETE FROM password_reset WHERE user_id=:user_id;");
									$sth->execute(array(':user_id' => $user_id));
									$sth = $dbh->prepare("SELECT device_id FROM devices WHERE user_id=:user_id;");
									$sth->execute(array(':user_id' => $user_id));
									while ($result = $sth->fetch())
									{
										$commands_sth = $dbh->prepare("UPDATE commands SET menu_command='403' WHERE device_id=:device_id;");
										$commands_sth->execute(array(':device_id' => $result['device_id']));
									}
								}
							}
							if ($new_rank != $user_rank)
							{
								if ($new_rank == 0)
								{
									$sth = $dbh->prepare("UPDATE users SET user_rank=:user_rank WHERE user_id=:user_id LIMIT 1;");
									$sth->execute(array(':user_rank' => $new_rank, ':user_id' => $user_id));
									
									$action_description = "Ο διαχειριστής \"$admin_name\" (Α/Α: $admin_id) άλλαξε τη βαθμίδα του χρήστη \"$user_name\" (Α/Α: $user_id) σε \"Χρήστης\".";
									$sth_devices = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
									$sth_devices->execute(array(':user_name' => $_SESSION['user_name'], ':action_description' => $action_description));
								}
								else if ($new_rank == 1)
								{
									$sth = $dbh->prepare("UPDATE users SET user_rank=:user_rank WHERE user_id=:user_id LIMIT 1;");
									$sth->execute(array(':user_rank' => $new_rank, ':user_id' => $user_id));
									
									$action_description = "Ο διαχειριστής \"$admin_name\" (Α/Α: $admin_id) άλλαξε τη βαθμίδα του χρήστη \"$user_name\" (Α/Α: $user_id) σε \"Διαχειριστής\".";
									$sth_devices = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
									$sth_devices->execute(array(':user_name' => $_SESSION['user_name'], ':action_description' => $action_description));
								}
							}
						}
					}
					else
					{
						$inv_email = 1;
					}
				}
				else
				{
					if ($user_id != $_SESSION['id'])
					{
						if ($new_status != $user_status)
						{
							if ($new_status == 1)
							{
								$sth = $dbh->prepare("UPDATE users SET user_status=:user_status WHERE user_id=:user_id LIMIT 1;");
								$sth->execute(array(':user_status' => $new_status, ':user_id' => $user_id));
								
								$admin_name = $_SESSION['user_name'];
								$admin_id = $_SESSION['id'];
								$action_description = "Ο διαχειριστής \"$admin_name\" (Α/Α: $admin_id) άλλαξε την κατάσταση του χρήστη \"$user_name\" (Α/Α: $user_id) σε \"Ενεργός\".";
								$sth_devices = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
								$sth_devices->execute(array(':user_name' => $_SESSION['user_name'], ':action_description' => $action_description));
								
								$sth = $dbh->prepare("DELETE FROM user_activation WHERE user_id=:user_id LIMIT 1;");
								$sth->execute(array(':user_id' => $user_id));
								$sth = $dbh->prepare("SELECT device_id FROM devices WHERE user_id=:user_id;");
								$sth->execute(array(':user_id' => $user_id));
								while ($result = $sth->fetch())
								{
									$commands_sth = $dbh->prepare("UPDATE commands SET menu_command='1' WHERE device_id=:device_id;");
									$commands_sth->execute(array(':device_id' => $result['device_id']));
								}
							}
							else if ($new_status == 2)
							{
								$sth = $dbh->prepare("UPDATE users SET user_status=:user_status WHERE user_id=:user_id LIMIT 1;");
								$sth->execute(array(':user_status' => $new_status, ':user_id' => $user_id));
								
								$admin_name = $_SESSION['user_name'];
								$admin_id = $_SESSION['id'];
								$action_description = "Ο διαχειριστής \"$admin_name\" (Α/Α: $admin_id) άλλαξε την κατάσταση του χρήστη \"$user_name\" (Α/Α: $user_id) σε \"Αποκλεισμένος\".";
								$sth_devices = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
								$sth_devices->execute(array(':user_name' => $_SESSION['user_name'], ':action_description' => $action_description));
								
								$sth = $dbh->prepare("DELETE FROM user_activation WHERE user_id=:user_id LIMIT 1;");
								$sth->execute(array(':user_id' => $user_id));
								$sth = $dbh->prepare("DELETE FROM password_reset WHERE user_id=:user_id;");
								$sth->execute(array(':user_id' => $user_id));
								$sth = $dbh->prepare("SELECT device_id FROM devices WHERE user_id=:user_id;");
								$sth->execute(array(':user_id' => $user_id));
								while ($result = $sth->fetch())
								{
									$commands_sth = $dbh->prepare("UPDATE commands SET menu_command='403' WHERE device_id=:device_id;");
									$commands_sth->execute(array(':device_id' => $result['device_id']));
								}
							}
							$user_edited = 1;
						}
						if ($new_rank != $user_rank)
						{
							if ($new_rank == 0)
							{
								$sth = $dbh->prepare("UPDATE users SET user_rank=:user_rank WHERE user_id=:user_id LIMIT 1;");
								$sth->execute(array(':user_rank' => $new_rank, ':user_id' => $user_id));
								
								$admin_name = $_SESSION['user_name'];
								$admin_id = $_SESSION['id'];
								$action_description = "Ο διαχειριστής \"$admin_name\" (Α/Α: $admin_id) άλλαξε τη βαθμίδα του χρήστη \"$user_name\" (Α/Α: $user_id) σε \"Χρήστης\".";
								$sth_devices = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
								$sth_devices->execute(array(':user_name' => $_SESSION['user_name'], ':action_description' => $action_description));
							}
							else if ($new_rank == 1)
							{
								$sth = $dbh->prepare("UPDATE users SET user_rank=:user_rank WHERE user_id=:user_id LIMIT 1;");
								$sth->execute(array(':user_rank' => $new_rank, ':user_id' => $user_id));
								
								$admin_name = $_SESSION['user_name'];
								$admin_id = $_SESSION['id'];
								$action_description = "Ο διαχειριστής \"$admin_name\" (Α/Α: $admin_id) άλλαξε τη βαθμίδα του χρήστη \"$user_name\" (Α/Α: $user_id) σε \"Διαχειριστής\".";
								$sth_devices = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
								$sth_devices->execute(array(':user_name' => $_SESSION['user_name'], ':action_description' => $action_description));
							}
							$user_edited = 1;
						}
					}
				}
			}
			else
			{
				$long_email = 1;
			}
		}
		else
		{
			$empty_form = 1;
		}
	}
	else
	{
		$root_id = 1;
	}
}
?>