<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
$require_variable = 1;
require 'php_scripts/force_https_session_script.php';
if (isset($_SESSION['activate_id']))
{
	$user_id = $_SESSION['activate_id'];
	unset($_SESSION['activate_id']);
	require 'php_scripts/db_connect_script.php';
	
	$sth = $dbh->prepare("SELECT user_name, user_email FROM users WHERE user_id=:user_id LIMIT 1;");
    $sth->execute(array(':user_id' => $user_id));
    $result = $sth->fetch();
    
    $user_name = $result['user_name'];
    $to = $result['user_email'];
    
    $sth = $dbh->prepare("SELECT activation_hash FROM user_activation WHERE user_id=:user_id LIMIT 1;");
    $sth->execute(array(':user_id' => $user_id));
    $result = $sth->fetch();
    
    if ($sth->rowCount() == 1)
    {
    	$activation_hash = $result['activation_hash'];	
     		
    	$subject = "Υπενθύμιση ενεργοποίησης λογαριασμού";
    	$server = $_SERVER['SERVER_NAME'];
    	$headers = "MIME-Version: 1.0\r\nContent-type:text/html;charset=UTF-8\r\nFrom: admin@$server";
    	$path = dirname($_SERVER['SCRIPT_NAME']);
    	$body = "Γεια σας $user_name,<br /><br />Αυτό είναι το e-mail ενεργοποίησης που ζητήσατε. Ακολουθήστε τον παρακάτω σύνδεσμο για να ενεργοποιήσετε τον λογαριασμό σας!<br />https://$server$path/index.php?id=$user_id&activation_hash=$activation_hash";
    	
    	if(mail($to, $subject, $body, $headers))
    	{
			$action_description = "Ο χρήστης \"$user_name\" (Α/Α: $user_id) ζήτησε επαναποστολή του e-mail ενεργοποίησης.";
			$sth = $dbh->prepare("INSERT INTO users_logs (log_id, timestamp, user_name, action_description) VALUES ('', NOW(), :user_name, :action_description);");
			$sth->execute(array(':user_name' => $user_name, ':action_description' => $action_description));
			
			$dbh = NULL;
    		$_SESSION['resent'] = 1;
    		header("Location: index.php");
    		die();
    	}
    	else
    	{
    		$dbh = NULL;
    		$_SESSION['SMTP_error'] = 1;
    		header("Location: index.php");
    		die();
    	}
    }
    else
    {
    	$dbh = NULL;
    	$_SESSION['db_error'] = 1;
    	header("Location: index.php");
    	die();
    }
}
else
{
	$_SESSION['inv_link'] = 1;
	header("Location: index.php");
	die();
}
exit();
?>