<?php
/***************************************************************************
* Copyright 2015 Panagiotis Ioannidis - Minas Dasygenis                    *
*                                                                          *
* Licensed under the Apache License, Version 2.0 (the "License");          *
* you may not use this file except in compliance with the License.         *
* You may obtain a copy of the License at                                  *
*                                                                          *
*     http://www.apache.org/licenses/LICENSE-2.0                           *
*                                                                          *
* Unless required by applicable law or agreed to in writing, software      *
* distributed under the License is distributed on an "AS IS" BASIS,        *
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
* See the License for the specific language governing permissions and      *
* limitations under the License.                                           *
***************************************************************************/
$require_variable = 1;
require 'php_scripts/force_https_session_script.php';
require 'php_scripts/login_check_script.php';
require 'php_scripts/admin_check_script.php';
require 'php_scripts/db_connect_script.php';
require 'php_scripts/user_admin_manage_script.php';

require 'include/head.php';
echo "<title>Διαχείριση Χρήστη \"$user_name\"</title>";
echo "</head><body>";
require 'include/nav_menu.php';
?>

<div class='container'>
	<div class='row'>
		<?php require 'php_alerts/user_admin_manage_alerts.php'; ?>
	</div>
	<div class='row'>
		<?php echo "<div class='page_title'><a href='user_admin_manage.php?user_id=$user_id'>Διαχείριση Χρήστη</a></div>"; ?>
	</div>
	<div class='row'>
		<hr />
		<div class='col-md-2 hidden-xs hidden-sm text-center'>
		</div>
		<div class='col-md-4 text-center'>
			<form action='user_admin_manage.php?user_id=<?php echo $user_id; ?>' class='form-horizontal' id='device_add_form' name='user_admin_manage' method='POST'>
				<label for='user_email_manage'>Διεύθυνση e-mail</label>
  				<input type='text' class='form-control' id='user_email_manage' name='email'<?php if(isset($new_email)) { echo "value='$new_email'"; } else { echo "value='$user_email'"; } if ($_SESSION['id'] != 1 && $user_id == 1) { echo " disabled"; } ?>>
				<label for='user_rank_manage'>Βαθμίδα</label>
				<div id='user_rank_manage' class='btn-group btn-group-justified' data-toggle='buttons'>
					<label class='btn btn-default<?php if(isset($new_rank) && $new_rank == 0) { echo " active"; } else if (!isset($new_rank) && $user_rank == 0) { echo " active"; } ?><?php if ($user_id == 1 || $user_id == $_SESSION['id']) { echo " disabled"; } ?>'>
						<input type='radio' name='rank' value='0' id='rank_option1' autocomplete='off'<?php if(isset($new_rank) && $new_rank == 0) { echo " checked"; } else if (!isset($new_rank) && $user_rank == 0) { echo " checked"; } ?>>Χρήστης
					</label>
					<label class='btn btn-default<?php if(isset($new_rank) && $new_rank == 1) { echo " active"; } else if (!isset($new_rank) && $user_rank == 1) { echo " active"; } ?><?php if ($user_id == 1 || $user_id == $_SESSION['id']) { echo " disabled"; } ?>'>
						<input type='radio' name='rank' value='1' id='rank_option2' autocomplete='off'<?php if(isset($new_rank) && $new_rank == 1) { echo " checked"; } else if (!isset($new_rank) && $user_rank == 1) { echo " checked"; } ?>>Διαχειριστής
					</label>
				</div>
				<label for='user_status_manage'>Κατάσταση</label>
				<div id='user_status_manage' class='btn-group btn-group-justified' data-toggle='buttons'>
					<label class='btn btn-default<?php if(isset($new_status) && $new_status == 1) { echo " active"; } else if (!isset($new_status) && $user_status == 1) { echo " active"; } ?><?php if ($user_id == 1 || $user_id == $_SESSION['id']) { echo " disabled"; } ?>'>
						<input type='radio' name='status' value='1' id='status_option1' autocomplete='off'<?php if(isset($new_status) && $new_status == 1) { echo " checked"; } else if (!isset($new_status) && $user_status == 1) { echo " checked"; } ?>>Ενεργός
					</label>
					<label class='btn btn-default<?php if(isset($new_status) && $new_status == 2) { echo " active"; } else if (!isset($new_status) && $user_status == 2) { echo " active"; } ?><?php if ($user_id == 1 || $user_id == $_SESSION['id']) { echo " disabled"; } ?>'>
						<input type='radio' name='status' value='2' id='status_option2' autocomplete='off'<?php if(isset($new_status) && $new_status == 2) { echo " checked"; } else if (!isset($new_status) && $user_status == 2) { echo " checked"; } ?>>Αποκλεισμένος
					</label>
				</div>
				<input name='user_admin_manage' class='btn btn-primary btn-block form_button<?php if ($_SESSION['id'] != 1 && $user_id == 1) { echo " disabled"; } ?>' type='submit' value='Ενημέρωση'>
			</form>
		</div>
		<div class='col-md-4 text-center'>
			<div class='hidden-md hidden-lg'>
				<hr />
			</div>
			<label for='device_add_form'>Προσθήκη νέας συσκευής</label>
			<form action='user_admin_manage.php?user_id=<?php echo $user_id; ?>' id='device_add_form' name='user_admin_device_add_form' method='POST'>
				<input type='text' class='form-control' placeholder='όνομα συσκευής' name='new_device_name'<?php if(isset($new_device_name)) {echo "value='$new_device_name'";} ?>>
				<input name='user_admin_device_add' class='btn btn-primary btn-block form_button' type='submit' value='Προσθήκη'>
			</form>
		</div>
		<div class='col-md-2 hidden-xs hidden-sm text-center'>
		</div>
	</div>
	<hr />
	<?php require 'php_echoes/user_admin_manage_echoes.php'; ?>
	<div class='row'>
		<a href='users_admin.php'>Πίσω</a>
	</div>
</div>

<?php
$dbh = NULL;
require 'include/footer.php';
exit();
?>